List Pools
Returns a list of all Uniswap V3 liquidity pools on a given EVM chain, including token pair details, fee tiers, tick spacing, and pool creation timestamps. Results can be filtered by chain or token address and sorted by any returned column.
GET
https://api.cambrian.org/evm/uniswap/v3/pools
Parameters
chain_id (integer)
EVM chain ID.
token_address (string)
Pool token address. See tokens for valid addresses.
limit (integer)
Limit the number of results.
offset (integer)
Offset the results, allows you to skip a number of rows before starting to return rows.
order_asc (array)
List of column names to order by in ascending order divided by comma. Leave empty items to combine with descending order
order_desc (array)
List of column names to order by in descending order divided by comma. Leave empty items to combine with ascending order
Responses
Code
Description
200
Successful response
Media type: application/vnd.cambrian.table.v1.0.0+json
[
{
"columns": [
{
"name": "chainId",
"type": "UInt16"
},
{
"name": "dexAddress",
"type": "FixedString(42)"
},
{
"name": "dexName",
"type": "String"
},
{
"name": "poolAddress",
"type": "FixedString(42)"
},
{
"name": "token0Address",
"type": "String"
},
{
"name": "token0Symbol",
"type": "String"
},
{
"name": "token0Decimals",
"type": "UInt8"
},
{
"name": "token1Address",
"type": "String"
},
{
"name": "token1Symbol",
"type": "String"
},
{
"name": "token1Decimals",
"type": "UInt8"
},
{
"name": "createdAt",
"type": "DateTime('UTC')"
},
{
"name": "fee",
"type": "UInt32"
},
{
"name": "tickSpacing",
"type": "Int32"
}
],
"data": [
[
8453,
"0x33128a8fc17869897dce68ed026d694621f6fdfd",
"UniswapV3",
"0x59b797d630b9a6dea5722d2f6044fdf6b40e7185",
"0x0f61edbfe6cd86024c0f210c0695b08df55fdfc9",
"BSTONK",
18,
"0x833589fcd6edb6e08f4c7c32d4f71b54bda02913",
"USDC",
6,
"2026-10-23T21:09:23+00:00",
3000,
60
],
[
8453,
"0x33128a8fc17869897dce68ed026d694621f6fdfd",
"UniswapV3",
"0x267fbd5d7b55f9e781955aa92669bca3ba5a8ffa",
"0x4200000000000000000000000000000000000006",
"WETH",
18,
"0xf7bc0e6dfa81df3ba50973f28f7bb3f0abb36fe8",
"UP",
18,
"2026-10-23T21:02:43+00:00",
10000,
200
],
[
8453,
"0x33128a8fc17869897dce68ed026d694621f6fdfd",
"UniswapV3",
"0x784ca1409348e760fd27da7dbdf16f914dcba0c1",
"0x4200000000000000000000000000000000000006",
"WETH",
18,
"0xb7751b10aff6ce175a1ad4e377f2b51f3c5b4e15",
"ODIE",
18,
"2026-10-23T19:21:09+00:00",
3000,
60
],
[
8453,
"0x33128a8fc17869897dce68ed026d694621f6fdfd",
"UniswapV3",
"0xd634ac1442e8adde6278841c3c74d892af839c6d",
"0x2452763b61eb08c1cf255c4b629d30871a864563",
"UHI",
18,
"0x4200000000000000000000000000000000000006",
"WETH",
18,
"2026-10-23T19:13:53+00:00",
3000,
60
],
[
8453,
"0x33128a8fc17869897dce68ed026d694621f6fdfd",
"UniswapV3",
"0x61635ff56efe3912e52da4e15e97f59196226866",
"0x4200000000000000000000000000000000000006",
"WETH",
18,
"0xa205c62147da8858d7faaad38992cf658f23075a",
"XLM",
18,
"2026-10-23T19:03:49+00:00",
3000,
60
],
[
8453,
"0x33128a8fc17869897dce68ed026d694621f6fdfd",
"UniswapV3",
"0xe17b8d05471d9552d83d05947a12b7096433548c",
"0x4200000000000000000000000000000000000006",
"WETH",
18,
"0xf9465bf5395f9af9755c6469fba9366ecb099f8e",
"UHI",
18,
"2026-10-23T18:44:31+00:00",
3000,
60
],
[
8453,
"0x33128a8fc17869897dce68ed026d694621f6fdfd",
"UniswapV3",
"0x97f9e41681e9883c8c6cca30d547a15e1e1c3f35",
"0x4200000000000000000000000000000000000006",
"WETH",
18,
"0x60f54c60fc68a0e7bf4034d0ac069b862ed61c37",
"IRYS",
18,
"2026-10-23T18:33:55+00:00",
3000,
60
],
[
8453,
"0x33128a8fc17869897dce68ed026d694621f6fdfd",
"UniswapV3",
"0x42438ec332f46c596b7cacc18c840ff945e4a83a",
"0x13769a4e7e74f4fd1652329c848686516777896c",
"DEFI",
18,
"0x4200000000000000000000000000000000000006",
"WETH",
18,
"2026-10-23T18:31:55+00:00",
10000,
200
],
[
8453,
"0x33128a8fc17869897dce68ed026d694621f6fdfd",
"UniswapV3",
"0x45ba33fa940984e236cdd1198b384de0a17779d0",
"0x4200000000000000000000000000000000000006",
"WETH",
18,
"0xa457c67ff888743cb6c117292e418088cdb1c39f",
"DRV",
18,
"2026-10-23T18:30:05+00:00",
10000,
200
],
[
8453,
"0x33128a8fc17869897dce68ed026d694621f6fdfd",
"UniswapV3",
"0x6314d5c893db1b1d1a96ae3759b70e7948bbfa45",
"0x4200000000000000000000000000000000000006",
"WETH",
18,
"0xca423ed70d834b55ebc218c5b0d8589145d0670e",
"BCAT",
18,
"2026-10-23T18:29:55+00:00",
10000,
200
]
],
"rows": 10
}
]
400
Bad Request: Invalid request parameters or malformed request.
401
Unauthorized: Missing or invalid API key. Include X-API-Key header with your request.
403
Forbidden: Invalid API key or insufficient permissions to access this resource.
404
Not Found: Endpoint or resource does not exist.
408
Request Timeout: Request took too long to process. Try again.
500
Internal Server Error: An unexpected error occurred while processing your request.
503
Service Unavailable: The server is temporarily unable to handle the request. Please try again later.
Examples
1. List recent Uniswap V3 pools on Base
Retrieves the most recently created Uniswap V3 pools on Base (chain ID 8453, the default), limited to 10 results.
curl
curl -X GET "https://api.cambrian.org/evm/uniswap/v3/pools?limit=10" \
-H "X-API-Key: YOUR_API_KEY" \
-H "Content-Type: application/json"
Response:
JSON
1[
2 {
3 "columns": [
4 {
5 "name": "chainId",
6 "type": "UInt16"
7 },
8 {
9 "name": "dexAddress",
10 "type": "FixedString(42)"
11 },
12 {
13 "name": "dexName",
14 "type": "String"
15 },
16 {
17 "name": "poolAddress",
18 "type": "FixedString(42)"
19 },
20 {
21 "name": "token0Address",
22 "type": "String"
23 },
24 {
25 "name": "token0Symbol",
26 "type": "String"
27 },
28 {
29 "name": "token0Decimals",
30 "type": "UInt8"
31 },
32 {
33 "name": "token1Address",
34 "type": "String"
35 },
36 {
37 "name": "token1Symbol",
38 "type": "String"
39 },
40 {
41 "name": "token1Decimals",
42 "type": "UInt8"
43 },
44 {
45 "name": "createdAt",
46 "type": "DateTime('UTC')"
47 },
48 {
49 "name": "fee",
50 "type": "UInt32"
51 },
52 {
53 "name": "tickSpacing",
54 "type": "Int32"
55 }
56 ],
57 "data": [
58 [
59 8453,
60 "0x33128a8fc17869897dce68ed026d694621f6fdfd",
61 "UniswapV3",
62 "0x59b797d630b9a6dea5722d2f6044fdf6b40e7185",
63 "0x0f61edbfe6cd86024c0f210c0695b08df55fdfc9",
64 "BSTONK",
65 18,
66 "0x833589fcd6edb6e08f4c7c32d4f71b54bda02913",
67 "USDC",
68 6,
69 "2026-10-23T21:09:23+00:00",
70 3000,
71 60
72 ],
73 [
74 8453,
75 "0x33128a8fc17869897dce68ed026d694621f6fdfd",
76 "UniswapV3",
77 "0x267fbd5d7b55f9e781955aa92669bca3ba5a8ffa",
78 "0x4200000000000000000000000000000000000006",
79 "WETH",
80 18,
81 "0xf7bc0e6dfa81df3ba50973f28f7bb3f0abb36fe8",
82 "UP",
83 18,
84 "2026-10-23T21:02:43+00:00",
85 10000,
86 200
87 ],
88 [
89 8453,
90 "0x33128a8fc17869897dce68ed026d694621f6fdfd",
91 "UniswapV3",
92 "0x784ca1409348e760fd27da7dbdf16f914dcba0c1",
93 "0x4200000000000000000000000000000000000006",
94 "WETH",
95 18,
96 "0xb7751b10aff6ce175a1ad4e377f2b51f3c5b4e15",
97 "ODIE",
98 18,
99 "2026-10-23T19:21:09+00:00",
100 3000,
101 60
102 ],
103 [
104 8453,
105 "0x33128a8fc17869897dce68ed026d694621f6fdfd",
106 "UniswapV3",
107 "0xd634ac1442e8adde6278841c3c74d892af839c6d",
108 "0x2452763b61eb08c1cf255c4b629d30871a864563",
109 "UHI",
110 18,
111 "0x4200000000000000000000000000000000000006",
112 "WETH",
113 18,
114 "2026-10-23T19:13:53+00:00",
115 3000,
116 60
117 ],
118 [
119 8453,
120 "0x33128a8fc17869897dce68ed026d694621f6fdfd",
121 "UniswapV3",
122 "0x61635ff56efe3912e52da4e15e97f59196226866",
123 "0x4200000000000000000000000000000000000006",
124 "WETH",
125 18,
126 "0xa205c62147da8858d7faaad38992cf658f23075a",
127 "XLM",
128 18,
129 "2026-10-23T19:03:49+00:00",
130 3000,
131 60
132 ],
133 [
134 8453,
135 "0x33128a8fc17869897dce68ed026d694621f6fdfd",
136 "UniswapV3",
137 "0xe17b8d05471d9552d83d05947a12b7096433548c",
138 "0x4200000000000000000000000000000000000006",
139 "WETH",
140 18,
141 "0xf9465bf5395f9af9755c6469fba9366ecb099f8e",
142 "UHI",
143 18,
144 "2026-10-23T18:44:31+00:00",
145 3000,
146 60
147 ],
148 [
149 8453,
150 "0x33128a8fc17869897dce68ed026d694621f6fdfd",
151 "UniswapV3",
152 "0x97f9e41681e9883c8c6cca30d547a15e1e1c3f35",
153 "0x4200000000000000000000000000000000000006",
154 "WETH",
155 18,
156 "0x60f54c60fc68a0e7bf4034d0ac069b862ed61c37",
157 "IRYS",
158 18,
159 "2026-10-23T18:33:55+00:00",
160 3000,
161 60
162 ],
163 [
164 8453,
165 "0x33128a8fc17869897dce68ed026d694621f6fdfd",
166 "UniswapV3",
167 "0x42438ec332f46c596b7cacc18c840ff945e4a83a",
168 "0x13769a4e7e74f4fd1652329c848686516777896c",
169 "DEFI",
170 18,
171 "0x4200000000000000000000000000000000000006",
172 "WETH",
173 18,
174 "2026-10-23T18:31:55+00:00",
175 10000,
176 200
177 ],
178 [
179 8453,
180 "0x33128a8fc17869897dce68ed026d694621f6fdfd",
181 "UniswapV3",
182 "0x45ba33fa940984e236cdd1198b384de0a17779d0",
183 "0x4200000000000000000000000000000000000006",
184 "WETH",
185 18,
186 "0xa457c67ff888743cb6c117292e418088cdb1c39f",
187 "DRV",
188 18,
189 "2026-10-23T18:30:05+00:00",
190 10000,
191 200
192 ],
193 [
194 8453,
195 "0x33128a8fc17869897dce68ed026d694621f6fdfd",
196 "UniswapV3",
197 "0x6314d5c893db1b1d1a96ae3759b70e7948bbfa45",
198 "0x4200000000000000000000000000000000000006",
199 "WETH",
200 18,
201 "0xca423ed70d834b55ebc218c5b0d8589145d0670e",
202 "BCAT",
203 18,
204 "2026-10-23T18:29:55+00:00",
205 10000,
206 200
207 ]
208 ],
209 "rows": 10
210 }
211]
2 {
3 "columns": [
4 {
5 "name": "chainId",
6 "type": "UInt16"
7 },
8 {
9 "name": "dexAddress",
10 "type": "FixedString(42)"
11 },
12 {
13 "name": "dexName",
14 "type": "String"
15 },
16 {
17 "name": "poolAddress",
18 "type": "FixedString(42)"
19 },
20 {
21 "name": "token0Address",
22 "type": "String"
23 },
24 {
25 "name": "token0Symbol",
26 "type": "String"
27 },
28 {
29 "name": "token0Decimals",
30 "type": "UInt8"
31 },
32 {
33 "name": "token1Address",
34 "type": "String"
35 },
36 {
37 "name": "token1Symbol",
38 "type": "String"
39 },
40 {
41 "name": "token1Decimals",
42 "type": "UInt8"
43 },
44 {
45 "name": "createdAt",
46 "type": "DateTime('UTC')"
47 },
48 {
49 "name": "fee",
50 "type": "UInt32"
51 },
52 {
53 "name": "tickSpacing",
54 "type": "Int32"
55 }
56 ],
57 "data": [
58 [
59 8453,
60 "0x33128a8fc17869897dce68ed026d694621f6fdfd",
61 "UniswapV3",
62 "0x59b797d630b9a6dea5722d2f6044fdf6b40e7185",
63 "0x0f61edbfe6cd86024c0f210c0695b08df55fdfc9",
64 "BSTONK",
65 18,
66 "0x833589fcd6edb6e08f4c7c32d4f71b54bda02913",
67 "USDC",
68 6,
69 "2026-10-23T21:09:23+00:00",
70 3000,
71 60
72 ],
73 [
74 8453,
75 "0x33128a8fc17869897dce68ed026d694621f6fdfd",
76 "UniswapV3",
77 "0x267fbd5d7b55f9e781955aa92669bca3ba5a8ffa",
78 "0x4200000000000000000000000000000000000006",
79 "WETH",
80 18,
81 "0xf7bc0e6dfa81df3ba50973f28f7bb3f0abb36fe8",
82 "UP",
83 18,
84 "2026-10-23T21:02:43+00:00",
85 10000,
86 200
87 ],
88 [
89 8453,
90 "0x33128a8fc17869897dce68ed026d694621f6fdfd",
91 "UniswapV3",
92 "0x784ca1409348e760fd27da7dbdf16f914dcba0c1",
93 "0x4200000000000000000000000000000000000006",
94 "WETH",
95 18,
96 "0xb7751b10aff6ce175a1ad4e377f2b51f3c5b4e15",
97 "ODIE",
98 18,
99 "2026-10-23T19:21:09+00:00",
100 3000,
101 60
102 ],
103 [
104 8453,
105 "0x33128a8fc17869897dce68ed026d694621f6fdfd",
106 "UniswapV3",
107 "0xd634ac1442e8adde6278841c3c74d892af839c6d",
108 "0x2452763b61eb08c1cf255c4b629d30871a864563",
109 "UHI",
110 18,
111 "0x4200000000000000000000000000000000000006",
112 "WETH",
113 18,
114 "2026-10-23T19:13:53+00:00",
115 3000,
116 60
117 ],
118 [
119 8453,
120 "0x33128a8fc17869897dce68ed026d694621f6fdfd",
121 "UniswapV3",
122 "0x61635ff56efe3912e52da4e15e97f59196226866",
123 "0x4200000000000000000000000000000000000006",
124 "WETH",
125 18,
126 "0xa205c62147da8858d7faaad38992cf658f23075a",
127 "XLM",
128 18,
129 "2026-10-23T19:03:49+00:00",
130 3000,
131 60
132 ],
133 [
134 8453,
135 "0x33128a8fc17869897dce68ed026d694621f6fdfd",
136 "UniswapV3",
137 "0xe17b8d05471d9552d83d05947a12b7096433548c",
138 "0x4200000000000000000000000000000000000006",
139 "WETH",
140 18,
141 "0xf9465bf5395f9af9755c6469fba9366ecb099f8e",
142 "UHI",
143 18,
144 "2026-10-23T18:44:31+00:00",
145 3000,
146 60
147 ],
148 [
149 8453,
150 "0x33128a8fc17869897dce68ed026d694621f6fdfd",
151 "UniswapV3",
152 "0x97f9e41681e9883c8c6cca30d547a15e1e1c3f35",
153 "0x4200000000000000000000000000000000000006",
154 "WETH",
155 18,
156 "0x60f54c60fc68a0e7bf4034d0ac069b862ed61c37",
157 "IRYS",
158 18,
159 "2026-10-23T18:33:55+00:00",
160 3000,
161 60
162 ],
163 [
164 8453,
165 "0x33128a8fc17869897dce68ed026d694621f6fdfd",
166 "UniswapV3",
167 "0x42438ec332f46c596b7cacc18c840ff945e4a83a",
168 "0x13769a4e7e74f4fd1652329c848686516777896c",
169 "DEFI",
170 18,
171 "0x4200000000000000000000000000000000000006",
172 "WETH",
173 18,
174 "2026-10-23T18:31:55+00:00",
175 10000,
176 200
177 ],
178 [
179 8453,
180 "0x33128a8fc17869897dce68ed026d694621f6fdfd",
181 "UniswapV3",
182 "0x45ba33fa940984e236cdd1198b384de0a17779d0",
183 "0x4200000000000000000000000000000000000006",
184 "WETH",
185 18,
186 "0xa457c67ff888743cb6c117292e418088cdb1c39f",
187 "DRV",
188 18,
189 "2026-10-23T18:30:05+00:00",
190 10000,
191 200
192 ],
193 [
194 8453,
195 "0x33128a8fc17869897dce68ed026d694621f6fdfd",
196 "UniswapV3",
197 "0x6314d5c893db1b1d1a96ae3759b70e7948bbfa45",
198 "0x4200000000000000000000000000000000000006",
199 "WETH",
200 18,
201 "0xca423ed70d834b55ebc218c5b0d8589145d0670e",
202 "BCAT",
203 18,
204 "2026-10-23T18:29:55+00:00",
205 10000,
206 200
207 ]
208 ],
209 "rows": 10
210 }
211]
x402 Payment Option
This endpoint supports pay-per-use access via the x402 payment protocol (v2): pay $0.05 USDC per request using blockchain micropayments. No API key required.
Quickstart (Typescript)
bash
npm install @x402/fetch @x402/evm viem
TypeScript
1import { x402Client } from "@x402/core/client";
2import { ExactEvmScheme } from "@x402/evm/exact/client";
3import { wrapFetchWithPayment } from "@x402/fetch";
4import { privateKeyToAccount } from "viem/accounts";
5const signer = privateKeyToAccount(process.env.EVM_PRIVATE_KEY as `0x${string}`);
6const client = new x402Client();
7client.register("eip155:*", new ExactEvmScheme(signer));
8const fetchWithPayment = wrapFetchWithPayment(fetch, client);
9const response = await fetchWithPayment(
10 "https://x402.cambrian.org/evm/uniswap/v3/pools"
11);
12const data = await response.json();
2import { ExactEvmScheme } from "@x402/evm/exact/client";
3import { wrapFetchWithPayment } from "@x402/fetch";
4import { privateKeyToAccount } from "viem/accounts";
5const signer = privateKeyToAccount(process.env.EVM_PRIVATE_KEY as `0x${string}`);
6const client = new x402Client();
7client.register("eip155:*", new ExactEvmScheme(signer));
8const fetchWithPayment = wrapFetchWithPayment(fetch, client);
9const response = await fetchWithPayment(
10 "https://x402.cambrian.org/evm/uniswap/v3/pools"
11);
12const data = await response.json();
Quickstart (Python)
bash
pip install "x402[httpx]"
Python
1import asyncio, os
2from eth_account import Account
3from x402 import x402Client
4from x402.http.clients import x402HttpxClient
5from x402.mechanisms.evm import EthAccountSigner
6from x402.mechanisms.evm.exact.register import register_exact_evm_client
7async def main():
8 client = x402Client()
9 account = Account.from_key(os.getenv("EVM_PRIVATE_KEY"))
10 register_exact_evm_client(client, EthAccountSigner(account))
11 async with x402HttpxClient(client) as http:
12 response = await http.get("https://x402.cambrian.org/evm/uniswap/v3/pools")
13 print(response.json())
14asyncio.run(main())
2from eth_account import Account
3from x402 import x402Client
4from x402.http.clients import x402HttpxClient
5from x402.mechanisms.evm import EthAccountSigner
6from x402.mechanisms.evm.exact.register import register_exact_evm_client
7async def main():
8 client = x402Client()
9 account = Account.from_key(os.getenv("EVM_PRIVATE_KEY"))
10 register_exact_evm_client(client, EthAccountSigner(account))
11 async with x402HttpxClient(client) as http:
12 response = await http.get("https://x402.cambrian.org/evm/uniswap/v3/pools")
13 print(response.json())
14asyncio.run(main())
Payment Flow
- Send a normal request to the endpoint (no API key needed)
- Server returns 402 Payment Required with payment details
- The x402 SDK automatically signs a payment authorization with your wallet
- The SDK resubmits the request with the signed payment
- Server verifies payment and returns the API response
The x402 SDK handles steps 2 through 5 automatically.
Network: Base (chain ID 8453) | Currency: USDC | Price: $0.05 per request